/* bed.h autoXml generated file */
#ifndef BED_H
#define BED_H

struct bedDasBed
    {
    struct bedDasBed *next;
    char *id;	/* Required */
    char *version;	/* Defaults to 1.0 */
    char *label;	/* Optional */
    char *description;	/* Optional */
    char *author;	/* Defaults to anonymous */
    char *href;	/* Optional */
    struct bedText *bedText;	/** Optional (may be NULL). **/
    struct bedSegment *bedSegment;	/** Possibly empty list. **/
    };

void bedDasBedSave(struct bedDasBed *obj, int indent, FILE *f);
/* Save bedDasBed to file. */

struct bedDasBed *bedDasBedLoad(char *fileName);
/* Load bedDasBed from file. */

struct bedText
    {
    struct bedText *next;
    char *text;
    };

void bedTextSave(struct bedText *obj, int indent, FILE *f);
/* Save bedText to file. */

struct bedText *bedTextLoad(char *fileName);
/* Load bedText from file. */

struct bedSegment
    {
    struct bedSegment *next;
    char *id;	/* Required */
    char *version;	/* Required */
    int start;	/* Required */
    int end;	/* Required */
    char *strand;	/* Required */
    struct bedF *bedF;	/** Possibly empty list. **/
    };

void bedSegmentSave(struct bedSegment *obj, int indent, FILE *f);
/* Save bedSegment to file. */

struct bedSegment *bedSegmentLoad(char *fileName);
/* Load bedSegment from file. */

struct bedF
    {
    struct bedF *next;
    char *id;	/* Required */
    int start;	/* Required */
    int end;	/* Required */
    char *label;	/* Optional */
    char *version;	/* Optional */
    char *description;	/* Optional */
    char *author;	/* Optional */
    char *href;	/* Optional */
    char *strand;	/* Optional */
    int score;	/* Defaults to -1 */
    int thickStart;	/* Defaults to -1 */
    int thickEnd;	/* Defaults to -1 */
    int frame;	/* Defaults to -1 */
    char *qId;	/* Optional */
    struct bedText *bedText;	/** Possibly empty list. **/
    struct bedF *bedF;	/** Possibly empty list. **/
    struct bedB *bedB;	/** Possibly empty list. **/
    };

void bedFSave(struct bedF *obj, int indent, FILE *f);
/* Save bedF to file. */

struct bedF *bedFLoad(char *fileName);
/* Load bedF from file. */

struct bedB
    {
    struct bedB *next;
    int start;	/* Required */
    int end;	/* Required */
    int score;	/* Defaults to -1 */
    char *qAli;	/* Optional */
    char *tAli;	/* Optional */
    int qStart;	/* Defaults to -1 */
    int qEnd;	/* Defaults to -1 */
    };

void bedBSave(struct bedB *obj, int indent, FILE *f);
/* Save bedB to file. */

struct bedB *bedBLoad(char *fileName);
/* Load bedB from file. */

#endif /* BED_H */

